.include "tn13def.inc"

.def    avg_cntL		=r0
.def    avg_cntH		=r1
.def 	errL			=r2
.def 	errH			=r3
.def 	duL				=r4
.def 	duH				=r5
.def 	diL				=r6
.def 	diH				=r7
.def 	disL			=r8
.def 	disH			=r9
.def 	isreg			=r10
.def 	inflex			=r11

.def 	avgL			=r12
.def 	avgM			=r13
.def 	avgH			=r14

.def 	zero			=r15

.def  	temp  			=r16
.def  	itemp  			=r17
.def  	pwmRaw 			=r18
.def 	frame			=r19
.def  	iset  			=r20
.def  	pwmL  			=r21
.def  	pwmH  			=r22
.def  	flags  			=r23
.def  	pairL  			=r24
.def  	pairH  			=r25
.def 	currL			=r26
.def 	currH			=r27
.def 	voltL			=r28
.def 	voltH			=r29
.def 	tempL			=r30
.def 	tempH			=r31
; XYZ - r27-r30 reserved

.equ MOD_IDLE	  	=  0
.equ MOD_ERROR	  	=  1
.equ MOD_FAST	  	=  2
.equ MOD_TOPP	  	=  3
.equ MOD_SLOW	  	=  4
.equ MOD_TRICKLE  	=  5
.equ MOD_DISCHG	  	=  6

.equ BAT_OK_VOLT	= 10 ;=5V , bat start voltage 86mV/step
.equ BAT_LOW_VOLT	= 240;140;=12V 126 ;=10.82V , bat discharge voltage 86mV/step
.equ SLOW_TIME		= 1 ; slow charge time, step 26.2144S
.equ SLOW_CURR		= 100;19 = 100ma, step 5.37ma
.equ TOPP_TIME		= 255;12=5 min topp charge time, step 26.2144S
.equ TOPP_CURR		= 70;

.equ FAST_CURR		= 112;112;600ma , step 5.37ma

.equ FAST_TIME		= 20 ;2S step 102,4ms
.equ FAST_SAMPLE	= 2;
.equ FAST_HOLD		= 20;
.equ FAST_SKIP		= 45; * FAST_TIME sampling
.equ FAST_TIMEOUT   = 5143; 3Hr  step 2,1s
;.equ FAST_DV_THR	= 6   ;2 min sample timeout if sum(dv)<=PRESET
.equ FAST_DV_PRE	= 0   ; preset  <0.3mv per 1.5min

.equ INFLEX_SEQ		= 0b00111100
.equ INFLEX_MASK	= 0b00111111
.equ INFLEX_MINSPD	= 70;25mV/m drop /1.5mV/30s

.equ MODE		  	= (0x60)
.equ VBATL		  	= (0x61)
.equ VBATH		  	= (0x62)
.equ OLD_VBATL		= (0x63)
.equ OLD_VBATH		= (0x64)
.equ dVBATL			= (0x65)
.equ dVBATH			= (0x66)
.equ TIMERL			= (0x67) 
.equ TIMERH			= (0x68) 
.equ TIMER_AUX		= (0x69)
.equ GTIMERL		= (0x6A)
.equ GTIMERH		= (0x6B)
.equ ZDV_COUNT		= (0x6C)
.equ ACC_DVL		= (0x6D)
.equ ACC_DVH		= (0x6E)
; -----------------------------------------------------
.equ PWM_PERIOD	= 120
.equ DISCHG	  	= 0
.equ PWMOUT	  	= 1
.equ LED	  	= 3
; -----------------------------------------------------
; flags
.equ FLAG_TIMER	  	= 0  ; timer = 0
.equ FLAG_NOLOAD  	= 1  ; 
; -----------------------------------------------------
.CSEG
.org 0x0000
rjmp RESET ; Reset Handler
reti ;rjmp EXT_INT0 ; IRQ0 Handler
reti ;rjmp PCINT0 ; PCINT0 Handler
reti ;rjmp TIM0_OVF ; Timer0 Overflow Handler
reti ;rjmp EE_RDY ; EEPROM Ready Handler
reti ; rjmp ANA_COMP ; Analog Comparator Handler
rjmp TIM0_COMPA ; Timer0 CompareA Handler
reti ;rjmp TIM0_COMPB ; Timer0 CompareB Handler
reti ;rjmp WATCHDOG ; Watchdog Interrupt Handler
reti ;rjmp ADC_INT ; ADC Conversion Handler
;------------------------------------------------------
modes:
rjmp _idle
rjmp _error
rjmp _fast
rjmp _topp
rjmp _slow
rjmp _trickle
rjmp _dischg
;------------------------------------------------------
TIM0_COMPA:
		out OCR0B,pwmRaw
		in isreg,SREG
		push itemp

		lsl pwmRaw
		sub errL,zero
		sbc errH,pwmRaw
		add errL,pwmL
		adc errH,pwmH
		mov pwmRaw,errH
		cpi pwmRaw,20
			brsh pwmshift
		clr pwmRaw
pwmshift:
		lsr pwmRaw

		inc frame
		andi frame,0x03
		sbrc frame,0
			rjmp frame2 
frame1:		
		clr pairH
		clr pairL
		add pairL,diL
		adc pairH,diH
		add pairL,duL
		adc pairH,duH
		add pairL,disL
		adc pairH,disH
		
		tst iset
		brne notzero
		clr pairL
		clr pairH
		rjmp notzero2
notzero:
		cbr flags,(1<<FLAG_NOLOAD)
notzero2:
		ldi itemp,-1
		cp disH,itemp
			brpl ts1
;		subi pairL,0
;		sbci pairH,20
;		clr pwmH
;		clr pwmL
		nop
ts1:
		tst pairH
			brmi ltpwm

		add pwmL,pairL
		adc pwmH,pairH 
			brcc plpwm
		sub pwmL,pairL
		sbc pwmH,pairH
plpwm:
		cpi pwmH,221
			brlo pwmok
		ldi pwmH,220
		clr pwmL
			rjmp fin
ltpwm:
		com pairL
		com pairH
		subi pairL,255
		sbci pairH,255
		sub pwmL,pairL
		sbc pwmH,pairH 
			brcc pwmok
		clr pwmH
		clr pwmL
pwmok:
			rjmp fin
frame2:  
		sbrc frame,1
			rjmp sub2			
sub1:   ; Current
		
		ldi itemp, 0x40+1  ; select voltage
		
		movw diH:diL,currH:currL
		in currL,ADCL
		in currH,ADCH
		out ADMUX,itemp
		sbi ADCSRA,ADSC	

		sub diL,currL
		sbc diH,currH

		mov disL,iset
		mov disH,zero
		sub disL,currL
		sbc disH,currH
		lsl diL
		rol diH
		lsl diL
		rol diH

		ldi pairL,0xF0
		ldi pairH,0x03
		cp voltL,pairL
		cpc voltH,pairH
			brcs fin
		clr pwmH
		clr pwmL
		clr iset
		sbr flags,(1<<FLAG_NOLOAD)
			rjmp fin
sub2:   ; Voltage
		ldi itemp, 0x40+2  ; select current
		movw duH:duL,voltH:voltL
		in voltL,ADCL
		in voltH,ADCH
		out ADMUX,itemp
		nop
		sbi ADCSRA,ADSC
		sub duL,voltL
		sbc duH,voltH
		lsl duL
		rol duH
		lsl duL
		rol duH
		lsl duL
		rol duH
		
		tst avg_cntL
		brne collect
		tst avg_cntH
		brne collect
			rjmp fin
collect:		
		ldi itemp,1
		sub avg_cntL,itemp
		sbc avg_cntH,zero
		add avgL,voltL
		adc avgM,voltH
		adc avgH,zero		
fin:	pop itemp
		out SREG,isreg
			reti
;------------------------------------------------------
RESET:
		cli
		ldi temp, low(RAMEND)
		out SPL,temp

		ldi temp, 0x20
		out MCUCR,temp

		clr zero		
		clr avg_cntL
		clr avg_cntH

		out PORTB,zero
		ldi temp,(1<<PWMOUT)|(1<<LED)|(1<<DISCHG)
		out DDRB,temp

		clr pwmRaw
		ldi pwmL,101
		ldi pwmH,10

		ldi temp,PWM_PERIOD
		out OCR0A,temp
		ldi temp,20
		out OCR0B,temp

		ldi temp, 0x33
		out TCCR0A,temp	
		ldi temp, 0x09
		out TCCR0B,temp

		ldi temp,1<<OCIE0A
		out	TIMSK0,temp

		ldi temp, 0x40  ; 1V REF
		out ADMUX,temp
		ldi temp, 0b10000100 ; CK/16
		out ADCSRA,temp
		out ADCSRB,zero
		
;		ldi iset,112; = 600ma
		sei	
		clr iset
		clr pwmH
		clr pwmL
		clr errH
		clr errL

		rcall goto_idle
		;rcall goto_fast
		;rcall goto_topp
		clr flags
main_loop:
		sts VBATL,avgM
		sts VBATH,avgH
		rcall start_coll ; start data collection

		lds tempL,TIMERL
		lds tempH,TIMERH
		sbr flags,(1<<FLAG_TIMER)
		cp tempL,zero
		cpc tempH,zero
		breq time_done
		cbr flags,(1<<FLAG_TIMER)
		ldi temp,1
		sub tempL,temp
		sbc tempH,zero
		sts TIMERL,tempL
		sts TIMERH,tempH
time_done:
; led processing
		
; main part
		ldi ZH,high(modes)
		ldi ZL,low(modes)
		lds temp,MODE
		
		add ZL,temp
		adc ZH,zero
		icall 
main_fin:
		rcall stall_coll
	;	rcall show_avg
			rjmp 	main_loop
;------------------------------------------------------
;delay for 12,5uS * temp / 3,19ms max
;------------------------------------------------------
delay:
		push temp
dly_loop:	
		sleep
		dec temp	
		brne dly_loop
		pop temp
			ret
;------------------------------------------------------
zero_curr:
		clr iset
		clr pwmH
		clr pwmL			
			ret
;------------------------------------------------------
goto_topp:
		ldi temp,MOD_TOPP		; go to slow charge
		sts MODE,temp
		ldi temp,TOPP_TIME
		sts TIMERL,zero
		sts TIMERH,temp
		ldi iset,SLOW_CURR
			ret
goto_slow:
		ldi temp,MOD_SLOW		; go to slow charge
		sts MODE,temp
		ldi temp,SLOW_TIME
		sts TIMERL,zero
		sts TIMERH,temp
		ldi iset,SLOW_CURR
			ret
goto_trickle:
		ldi temp,MOD_TRICKLE   ; go to trickle
		sts MODE,temp
			ret
goto_dsc:
		ldi temp,MOD_DISCHG   ; go to discharge
		sts MODE,temp
			ret
goto_fast:
		clr inflex
		sts	ACC_DVL,zero
		sts	ACC_DVH,zero
		sts ZDV_COUNT,zero
		lds tempL,VBATL
		lds tempH,VBATH
		sts OLD_VBATL,tempL
		sts OLD_VBATH,tempH
	
		ldi temp,high(FAST_TIMEOUT)
		sts GTIMERH,temp
		ldi temp,low(FAST_TIMEOUT)
		sts GTIMERL,temp

		ldi temp,FAST_TIME		
		sts TIMERH,zero
		sts TIMERL,temp
		sts TIMER_AUX,zero
		ldi temp,MOD_FAST   ; go to fast charge
		sts MODE,temp
			ret
goto_idle:
		rcall zero_curr		
		sts MODE,zero
			ret
goto_err:
		rcall zero_curr
		ldi temp,MOD_ERROR   ; go to err
		sts MODE,temp
		sbi PORTB,LED
			ret
;------------------------------------------------------
_idle:
		rcall zero_curr
		ldi temp,10
		sbi PORTB,LED
		sbi PORTB,DISCHG
			rcall delay ; delay 12,5x2 = 25uS
			rcall delay
		cbi PORTB,DISCHG ; discharging port
		cbi PORTB,LED

		lds temp,VBATH
		cpi temp,BAT_OK_VOLT
			brlo  done_idle
		rcall goto_dsc
done_idle:
			ret
;------------------------------------------------------
_fast:
		sbrs flags,FLAG_TIMER ; wait for timer to finish
		rjmp done_fast
		; ------------------ end of 2 second cycle
		ldi temp,FAST_TIME		
		sts TIMERH,zero
		sts TIMERL,temp
		
		lds temp,GTIMERL    ; count down 4 global timer
		sec
		sbc temp,zero
		sts GTIMERL,temp
		lds temp,GTIMERH
		sbc temp,zero
		sts GTIMERH,temp	
			breq call_err    ; timeout 
done_fast:
		lds temp,TIMERL
		cpi temp,FAST_HOLD
			brsh hold_part
		cpi temp,FAST_SAMPLE
			breq sample_part
		cpi temp,(FAST_HOLD-1)
			brne test_curr
		ldi iset,FAST_CURR 
		sbi PORTB,LED
test_curr:
		sbrc flags,FLAG_NOLOAD
call_err:
			rcall goto_err
			ret
hold_part:
		rcall zero_curr
		cbi PORTB,LED
			ret
sample_part:
		lds temp,TIMER_AUX
		inc temp
		cpi temp,FAST_SKIP
			brsh take_sample
		sts TIMER_AUX,temp
			ret
take_sample:
		sts TIMER_AUX,zero
zero_minusdv_test: ;-------------- 
		;lds temp,ZDV_COUNT
		;inc temp
		;sts ZDV_COUNT,temp
		;cpi temp,FAST_DV_THR
			;brlo dvmax_test
		;-------------- once per FAST_DV_THR cycles
		;sts ZDV_COUNT,zero

		lds tempL,VBATL
		lds tempH,VBATH
		lds temp, OLD_VBATL
		lds itemp,OLD_VBATH
		sts OLD_VBATL,tempL
		sts OLD_VBATH,tempH
		sub tempL,temp
		sbc tempH,itemp

		lds temp,dVBATL
		lds itemp,dVBATH
		sts dVBATL,tempL
		sts dVBATH,tempH
		
		cpi tempL,FAST_DV_PRE
		cpc tempH,zero
			brlt low_dv
			rjmp  dvmax_test
low_dv:	
			rcall goto_topp    ; continue
			;rcall goto_err    ; continue
			ret
dvmax_test:		
		;cpi tempL,INFLEX_MINSPD
		;cpc tempH,zero
		;	brlt ddv_minus ; speed lower than spd = 0

		cp tempL,temp
		cpc tempH,itemp ; compare 
			brmi ddv_minus 
ddv_plus2:
		sec
			rjmp ddv_plus
ddv_minus:
		sub temp,tempL
		sbc itemp,tempH
		cpi tempL,INFLEX_MINSPD
		cpc tempH,zero
		brlt ddv_plus2
		clc
ddv_plus:
		rol inflex
		ldi temp,INFLEX_MASK
		and inflex,temp
		ldi temp,INFLEX_SEQ
		cp inflex,temp
			brne no_dvv_max
			rcall goto_topp
;-------------- 
no_dvv_max:
			ret
;------------------------------------------------------
_error: ; wait for battery to be removed
		sbi PORTB,LED
		rcall zero_curr
		ldi temp,10
		sbi PORTB,DISCHG
			rcall delay ; delay 12,5x2 = 25uS
			rcall delay
		cbi PORTB,DISCHG ; discharging port

		lds temp,VBATH
		cpi temp,BAT_OK_VOLT
			brsh  done_err
			rcall goto_idle
done_err:
			ret
;------------------------------------------------------
_topp:
		sbrs flags,FLAG_TIMER ; wait for timer to finish
			rjmp done_topp
			rcall goto_err
done_topp:
		lds temp,TIMERL
		sbrc temp,5 ;
			rjmp topp_cen
			rcall zero_curr
			ret
topp_cen:	
		cbi PORTB,LED
		lds temp,TIMERL
		sbrs temp,0
		sbi PORTB,LED

		ldi iset,TOPP_CURR
		sbrc flags,FLAG_NOLOAD
			rcall goto_err
			ret
;------------------------------------------------------
_slow:	sbrs flags,FLAG_TIMER ; wait for timer to finish
			rjmp done_slow			
			rcall goto_fast
done_slow:
		cbi PORTB,LED
		lds temp,TIMERL
		sbrs temp,2
		sbi PORTB,LED
		sbrc flags,FLAG_NOLOAD
			rcall goto_err
			ret
;------------------------------------------------------
_trickle:
			ret
;------------------------------------------------------
_dischg:
		lds temp,VBATH
		cpi temp,BAT_LOW_VOLT
			brsh done_dch
		cbi PORTB,DISCHG ; disable load
		cbi PORTB,LED
			rcall goto_slow
			ret
done_dch:
		sbi PORTB,DISCHG
		sbi PORTB,LED
			ret
;------------------------------------------------------
show_avg:
		push temp
		push avgM
		push avgH

;		lds avgH,MODE

		ldi temp,16
		sbi PORTB,LED
		cbi PORTB,LED
plus:	
		cbi PORTB,LED
		sbi PORTB,LED
		sbrs avgH,7
		cbi PORTB,LED
		lsl avgM
		rol avgH
			sleep
.db "Neekeetos@yahoo.com",0x00
		dec temp
			brne plus
		cbi PORTB,LED
		pop avgH
		pop avgM
		pop temp
			ret
;------------------------------------------------------
start_coll:
		clr avgL
		clr avgM
		clr avgH
		ldi temp,8
;		ldi temp,1
		clr avg_cntL
		mov avg_cntH,temp  ; start collection
			ret
;------------------------------------------------------
stall_coll:
		sleep
		cp avg_cntL,zero
		cpc avg_cntH,zero
			brne stall_coll
		lsl avgL
		rol avgM
		rol avgH
		lsl avgL
		rol avgM
		rol avgH
		lsl avgL
		rol avgM
		rol avgH
		clr avgL
			ret
;------------------------------------------------------
